package uulm.teamname.marvelous.gamelibrary.gamelogic;

import uulm.teamname.marvelous.gamelibrary.events.Event;

import java.util.Observable;

/** Represents an event emitter for game events fired by a game instance. */
class EventEmitter extends Observable {
    /**
     * Emits an array of {@link Event}s. This method is necessary because {@link Observable#setChanged} is protected.
     * @param events The events to emit
     */
    public void update(Event... events) {
        setChanged();
        notifyObservers(events);
    }
}
